import bpy, os, math

# put in your decrypted "...sgb" file here
# create that with "sgb_conv.exe"
# use double backslashes \\ when using windows notation
inputfile = 'p:/acStuff/Bannochrea/Bannochbrae/bannochbrae1.xml'

selected_obj = bpy.context.selected_objects.copy()
bpy.ops.object.select_all(action='DESELECT')

def find_str(s, char):
    index = 0
    if len(char)>0 and char in s:
        c = char[0]
        for ch in s:
            if ch == c:
                if s[index:index+len(char)] == char:
                    return index
            index += 1
    return -1

lines = []
SEL_OBJ = []
c = 0
items = 0

if os.path.isfile(inputfile):
    with open(inputfile) as f:
        lines=f.read().splitlines()
cnt=len(lines)

if len(selected_obj) == 0 or cnt==0:
    print('nothing selected or inputfile empty...')
else:
    for obj in selected_obj:
        c=0
        while c<cnt:
            # currentObj = '"b_loda"'.lower() # debug
            currentObj = 'name="'+obj.name+'"'
            matrixLineIdx = -1
            if currentObj in lines[c].lower():
                if c+4<cnt and "<MATRIX" in lines[c+4]:
                    matrixLineIdx = 4
                elif c+3<cnt and "<MATRIX" in lines[c+3]:
                    matrixLineIdx = 3
                elif c+2<cnt and "<MATRIX" in lines[c+2]:
                    matrixLineIdx = 2
                elif c>1:
                    cBack = 2
                    while not "<MATRIX" in lines[c-cBack] and c-cBack>=0:
                        cBack = cBack + 4
                    matrixLineIdx = -cBack

                if matrixLineIdx!=-1:
                    p1     = find_str(lines[c+matrixLineIdx], 'Offset="')
                    matr   = lines [ c+matrixLineIdx][(p1+len('Offset="')): ]
                    orient = matr
                    unknown = matr

                    p2     = find_str(matr,'" Orientation="')
                    matr   = matr  [ :p2 ]

                    p3     = find_str(orient,'" Orientation="')
                    orient = orient  [ (p3+len('" Orientation="') ): ]

                    p4     = find_str(orient, '"')
                    orient = orient[ :p4 ]

                    p5     = find_str(unknown,'" unknown="')
                    unknown = unknown  [ (p5+len('" unknown="') ): ]
                    p6     = find_str(unknown,'"')
                    unknown = unknown[ :p6 ]

                    print('line ' + str(c) + ' ' + obj.name + '     ' + str(c+matrixLineIdx) + ' ' + matr + '  |  ' + orient + '  |  ' + unknown)

                    x,y,z=matr.split(' ')

                    bpy.data.objects[ obj.name ].select_set(True) # 2.8+
                    bpy.ops.object.duplicate_move(OBJECT_OT_duplicate={"linked":False, "mode":'TRANSLATION'},
                            TRANSFORM_OT_translate={"value":(float(x)/100.0, float(z)/100.0, float(y)/100.0), "orient_type":'GLOBAL',
                            "orient_matrix":((1, 0, 0), (0, 1, 0), (0, 0, 1)),
    "orient_matrix_type":'GLOBAL', "snap":True, "snap_target":'CLOSEST', "snap_point":(0, 0, 0)})

                    # could not figure out damn rotation

                    #xr,yr,zr=orient.split(' ')
                    #zt = float(yr) * 100.0
                    #unx, uny=unknown.split(' ')

                    #bpy.ops.transform.rotate(value = xt, orient_axis = 'X', orient_type='GLOBAL')
                    #bpy.ops.transform.rotate(value = zt, orient_axis = 'Y', orient_type='GLOBAL')
                    #bpy.ops.transform.rotate(value = yt, orient_axis = 'Z', orient_type='GLOBAL')

                    SEL_OBJ.append(bpy.context.selected_objects[0])

                    bpy.ops.object.select_all(action='DESELECT')
                    items = items + 1
            c += 1

    for o in SEL_OBJ:
        bpy.data.objects[ o.name ].select_set(True)

    if items>0:
        print(str(items) + " items duplicated")
