/*
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License version 2 as published by the Free Software Foundation.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public License
   along with this library; see the file COPYING.LIB.  If not, write to
   the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.
*/

#ifndef UTIL__H
#define UTIL__H
#include <stdint.h>
#include <stdio.h>

uint32_t swapBytes(uint32_t parValue);
int isString(uint32_t data);
char* getString(FILE *fp, size_t pos, char* parData);
size_t freadEndian(void *ptr, size_t size, size_t nmemb, FILE *stream, int endian);

#endif
