#ifndef OCCLUDER__HH
#define OCCLUDER__HH

#include <string>
#include <stdio.h>
#include "sgb.h"

class FileHandler;
class XmlElement;

class Occluder
{
    private:
        std::string myName;
        std::string myResource;
        point_t     myPoints[4];
    public:
        Occluder(FILE* fp, int endian);
        Occluder(XmlElement* parXml);
        int lengthRaw();
        XmlElement* toXml();
        void toRaw(FileHandler* parFh);

};

#endif

